package com.zipcodewilmington.phonebook;

import java.util.*;

/**
 * Created by leon on 1/23/18.
 */
public class PhoneBook {

    public TreeMap<String, String> book;

    public TreeMap<String, String> getBook() {
        return book;
    }

    public void setBook(TreeMap<String, String> book) {
        this.book = book;
    }

    public PhoneBook() {

        TreeMap<String, String> thebook = new TreeMap<>();
        setBook(thebook);
    }

    public boolean hasEntry(String name) {

        return book.containsKey(name);
    }

    public void add(String name, String phoneNumber) {

        if (book.containsKey(name)) {
            String value = book.get(name);
            value += ", " + phoneNumber;
            book.put(name, value);
        } else {
            book.put(name, phoneNumber);
        }
    }

    public String lookup (String name) {

        String value;

        if (book.containsKey(name)) {
            value = book.get(name);
        } else {
            value = "This name does not exist in our directory";
        }

        return value;
    }

    public void remove (String name){

        book.remove(name);

        if (book.containsKey(name)) {
            book.remove(name);
            System.out.println("The entry in the directory for " + name + " has been removed.");
        } else {
            System.out.println("This name does not exist in our directory");
        }
    }

    public String reverseLookup (String phoneNumber) {

        String val = "";
        Set ref = book.keySet();
        Iterator i = ref.iterator();

        while(i.hasNext()){
            Object temp = i.next();
                if (book.get(temp).equals(phoneNumber))
                { val = (String) temp; } }

            val = val.replace("[","");
            val = val.replace("]","");
        return val;
    }

    public void listNamesAndNumbers() {

        int counter = 0;

        for (Map.Entry m:book.entrySet()){
            counter++;
            System.out.println(m.getKey() +
                    " " + m.getValue());
            if (counter < book.size()) {System.out.print(System.lineSeparator());} }
    }

}
