package com.zipcodewilmington.phonebook;

import org.junit.Assert;
import org.junit.Test;

/**
 * Created by leon on 1/23/18.
 */
public class PhoneBookTest {


    @Test
    public void hasEntry() {
    }

    @Test
    public void add() {

        //Given
        String number = "888-999-9999";
        String name = "Joe";
        PhoneBook thebook = new PhoneBook();

        //When
        thebook.add(name, number);

        //Assert
        String actual = thebook.lookup(name);
        Assert.assertEquals(number, actual);

    }

    @Test
    public void lookup() {

        //Given
        String number = "111-222-3456";
        String name = "Jan";
        PhoneBook thebook = new PhoneBook();

        //When
        thebook.add(name, number);
        String actual = thebook.lookup(name);

        //Assert
        Assert.assertEquals(number, actual);

    }

    @Test
    public void remove() {

        //Given
        String number = "123-456-7890";
        String name = "Jones";
        PhoneBook thebook = new PhoneBook();

        //When
        thebook.add(name, number);
        thebook.remove(name);

        //Assert
        String actual = "This name does not exist in our directory";
        Assert.assertEquals(actual, actual);

    }

    @Test
    public void reverseLookup() {

        //Given
        String number = "123-456-7890";
        String name = "Jones";
        PhoneBook thebook = new PhoneBook();

        //When
        thebook.add(name, number);
        thebook.reverseLookup(number);

        //Assert
        Assert.assertEquals(name, name);

    }

    @Test
    public void listNamesAndNumbers() {

        //Given
        String number = "123-456-7890";
        String name = "Jacob";
        String number1 = "243-890-0947";
        String name1 = "Jimmy";
        PhoneBook thebook = new PhoneBook();

        //When
        thebook.add(name, number);
        thebook.add(name1, number1);

        //Assert
        String actual = name + " " + number + System.lineSeparator() + name1 + " " + number1;
        thebook.listNamesAndNumbers();
        Assert.assertEquals(actual, actual);
    }

}